dm "odsresults; clear";

options mprint;

proc format;
value agegroupf 
			0="<5"
			1="5-10"
			2="10-15"
			3=">15";
run;

proc contents data=sashelp.bmt;
run;

data bmt;
	set sashelp.bmt;
	age=floor(T/100);
	if age<5 then agegroup=0;
	else if age<10 then agegroup=1;
	else if age<15 then agegroup=2;
	else agegroup=3;
	format agegroup agegroupf.;
/*
	if group="ALL" then dgroup=1;
	if group="AML-Low Risk" then dgroup=2;
	if group="AML-High Risk" then dgroup=3;
	dgroup2=dgroup-1;
	format dgroup dgroupf.;
	format dgroup2 dgroup2f.;
*/
run;
proc contents data=bmt;
run;

proc phreg;
	class agegroup (param=ref ref=first);
	model t*status(1) = agegroup;
run;
proc phreg;
	class agegroup (param=ref ref='<5');
	model t*status(1) = agegroup;
run;

%macro uni(var,time,event,ref=0);
	/*
	var: covariate of interest
	time: time to event
	event: event indicator, 0=Censored 1=Event
	ref: numeric reference level, default 0
	*/
	data _NULL_;
		call symput('varformat',put(&ref,&var.f.)); 
		*assign the format corresponding to "0" to gloal var varformat;
	run;
	proc phreg data=bmt;
		class &var (param=ref ref="&varformat"); 
		*double quote can do substitution, not single;
		model &time*&event(1)=&var;
	run;
%mend;

%uni(agegroup,t,status,ref=2);
%uni(agegroup,t,status,ref=1);


